<?php

namespace Teknisa\FIN\Modules\ContaReceber\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\FIN\Modules\ContaReceber\Factory\GeralRecTipoajreceberFactory;

class GeralRecTipoajreceberService{

    protected $environment;
    protected $newCode;
    protected $entityManager;
    protected $factory;

    public function __construct($environment, $newCode, EntityManager $entityManager,
                                GeralRecTipoajreceberFactory $factory) {
        $this->environment = $environment;
        $this->newCode = $newCode;
        $this->entityManager = $entityManager;
        $this->factory = $factory;
	}

    public function insereParametroContaReceber($idbloqincntr, $idtpcntrlib, $idutctrlcanremr,
                                     $idbloqaltbolrec, $idutlnfdevolrec, $idutbcoprefclie,
                                     $idextelacalajubx){
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
        try {
            $cdgeralrec = $this->newCode->getCodeByTableName('GERAL_REC',$this->environment->getNrOrgTrab());
            $geralrec = $this->factory->insereParametroContaReceber(intVal($cdgeralrec), $idbloqincntr, $idtpcntrlib, $idutctrlcanremr,
                $idbloqaltbolrec, $idutlnfdevolrec, $idutbcoprefclie, $idextelacalajubx,$this->environment->getNrOrgTrab());
            $this->entityManager->persist($geralrec);
            $this->entityManager->flush();

            $this->entityManager->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollBack();
            throw $e;
        }
    }
    
    public function saveTabedsOperadores($row){
        try {
            $paramsGeralRec = array(
                   
               "IDBLOQINCNTR" => $row[0]["IDBLOQINCNTR"],
               "IDTPCNTRLIB" => $row[0]["IDTPCNTRLIB"],
               "IDUTLPRORVCREC" => $row[0]["IDUTLPRORVCREC"],
                "CDGERALREC" => 1
            );
                
            $paramsParamGeral = array(
                   
               "IDUTLPROCREC" => $row[0]["IDUTLPROCREC"],
               "IDCONTROLARECCONTRATO" => $row[0]["IDCONTROLARECCONTRATO"],
                "CDPARGERAL" => "0001"
            );

            $this->factory->atualizaTabelaGeralRec($paramsGeralRec);
            $this->factory->atualizaTabelaParamGeral($paramsParamGeral);

        } catch (\Exception $e) {
            throw $e;
        }
    }
}