<?php
namespace Avaliacao\Entities;

use Geral\Util\DateUtil;
use Geral\Util\NovoCodigo;
use Setforms2\Shared\Registry;

class Questavaliacao extends Base\Questavaliacao
{
    public function insereQuestavaliacao(
        $nrorg,
        $nrcombquestaval,
        $nrquestao,
        $ordenacao,
        $nrtemaanalise
    ){
        try {
            $obj = new self();

            $obj->setNrquestavalia(NovoCodigo::geraCodigo($nrorg, 'QUESTAVALIACAO',1,10,true));
            $obj->setNrcombquestaval($nrcombquestaval);
            $obj->setNrquestao($nrquestao);
            $obj->setNrordequestaval($ordenacao);
            $obj->setDtinclusao(DateUtil::getDataAtual());
            $obj->setDtultatu(DateUtil::getDataAtual());
            $obj->setIdativo('S');
            $obj->setNrnivelquestao(null);
            $obj->setNragrupquestava(null);
            $obj->setIdsortquestaval('SEM_SORTEIO');
            $obj->setVrnotaquestaval(0);
            $obj->setDsquestavalia(null);
            $obj->setTxcomplementoquestao(null);
            $obj->setNrtemaanalise($nrtemaanalise);
            $obj->setNrorg($nrorg);
            $obj->setNrorginclusao($nrorg);
            $obj->persist();

            Registry::getEntityManager()->flush();

            return true;

        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }

    }

    public static function retornaQuestaoAvaliacao($nrorg, $nravaliacao, $nrquestao, $txcomplementoquestao, $tema_analise){
        $txcomplementoquestao = ($txcomplementoquestao) ? " = '$txcomplementoquestao'" : 'IS NULL';
        $tema_analise = ($tema_analise) ? " = $tema_analise" : 'IS NULL';
        $query = "SELECT NRQUESTAVALIA
                    FROM QUESTAVALIACAO
                   WHERE NRORG = {$nrorg}
                     AND NRCOMBQUESTAVAL IN (SELECT NRCOMBQUESTAVAL FROM COMBQUESTAVAL WHERE NRAVALIACAO = {$nravaliacao})
                     AND NRQUESTAO          = {$nrquestao}
                     AND TXCOMPLEMENTOQUESTAO {$txcomplementoquestao}
                     AND NRTEMAANALISE {$tema_analise}";
        $result = \Setforms2\Runtime\Connection::getInstance()->fetchAll($query);
        return $result;
    }

    public static function consultaMesmaQuestaoAvaliacao($nrorg, $nravaliacao, $nrquestao){
        $query = "SELECT NRQUESTAVALIA
                    FROM QUESTAVALIACAO
                   WHERE NRORG = {$nrorg}
                     AND NRCOMBQUESTAVAL IN (SELECT NRCOMBQUESTAVAL FROM COMBQUESTAVAL WHERE NRAVALIACAO = {$nravaliacao})
                     AND NRQUESTAO          = {$nrquestao}";
        $result = \Setforms2\Runtime\Connection::getInstance()->fetchAll($query);
        return $result;
    }

    public function retornaQuestoesPorCombinacao($nrorg, $nrcombquestaval) {
        $objs = self::getObjectsByWhere(
            'NRORG = ? AND NRCOMBQUESTAVAL = ?',
            array(
                $nrorg,
                $nrcombquestaval,
            ),
            'ORDER BY NRORDEQUESTAVAL'
        );
        return $objs;
    }
    
    public static function insert(
                            $nrquestavalia,
                            $nrorg = 1,
                            $nrcombquestaval,
                            $nrquestao = null,
                            $nrnivelquestao = null,
                            $vrnotaquestaval,
                            $idsortquestaval = 'SEM_SORTEIO',
                            $dsquestavalia,
                            $nrordequestaval = null,
                            $dtinclusao,
                            $dtultatu = null,
                            $nrorginclusao = null,
                            $cdoperinclusao = null,
                            $nrorgultatu = null,
                            $cdoperultatu = null,
                            $nragrupquestava = null,
                            $idativo = 'S',
                            $txcomplementoquestao = null,
                            $nrtemaanalise = null,
                            $nravaliacao = null
    ){
        try {
            $obj = new self();

            $obj->setNrquestavalia(NovoCodigo::geraCodigo($nrorg, 'QUESTAVALIACAO',1,10,true));
            $obj->setNrorg($nrorg);
            $obj->setNrcombquestaval($nrcombquestaval);
            $obj->setNrquestao($nrquestao);
            $obj->setNrnivelquestao($nrnivelquestao);
            $obj->setVrnotaquestaval($vrnotaquestaval);
            $obj->setIdsortquestaval($idsortquestaval);
            $obj->setDsquestavalia($dsquestavalia);
            $obj->setNrordequestaval($nrordequestaval);
            $obj->setDtinclusao($dtinclusao);
            $obj->setDtultatu($dtultatu);
            $obj->setNrorginclusao($nrorginclusao);
            $obj->setCdoperinclusao($cdoperinclusao);
            $obj->setNrorgultatu($nrorgultatu);
            $obj->setCdoperultatu($cdoperultatu);
            $obj->setNragrupquestava($nragrupquestava);
            $obj->setIdativo($idativo);
            $obj->setTxcomplementoquestao($txcomplementoquestao);
            $obj->setNrtemaanalise($nrtemaanalise);
            $obj->setNravaliacao($nravaliacao);
            
            $obj->persist();

            Registry::getEntityManager()->flush();

            return true;

        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }

    }
}