<?php
namespace Geral\Entities;

use \Estoque\Entities\Lanctoestoq;

/**
 * @method findOneByNrorgAndCdfilialAndNrcardapioAndNrretirada($nrorg, $filial, $cardapio, $retirada) static
 */
class Itemreti extends Base\Itemreti
{


    const SIM = "S";
    const NAO = "N";


    public function insereItemRetirada(
        $nrorg, $filial, $nrLancto = null, $nrRetirada, $nrCardapio, $cdProdMovi, $seq, $qtRetirada = 0, $tipoRetirada,
        $integracao = null, $qtPrevisao = 0, $qtExtra = 0, $qtEvol = 0,
        $cdprato = null, $cdfilauxprat = null, $cdtipoprat = null, $operInclusao
    ){
        $dtInclusao = \Geral\Util\DateUtil::getDataAtual();

        if ($nrLancto) {
            $this->setNrlancestq($nrLancto);
            $this->setNrsequitem($seq);
            $this->setCdfiitlanest($filial);
        }

         if ($nrRetirada) {
            /** @var $objRetirada Retirada */
            $objRetirada = Retirada::getObject(
                array('nrorg' => $nrorg, 'cdfilial' => $filial, 'nrretirada' => $nrRetirada, 'nrcardapio' => $nrCardapio)
            );

            $this->setRetirada($objRetirada);
        }

        /** @var $objProduto Produto */
        $objProduto = Produto::getObject(array('nrorg' => $nrorg, 'cdproduto' => $cdProdMovi));

        $this->setCdfilial($filial);
        $this->setCdtiporeti($tipoRetirada);
        $this->setIdintesist($integracao);
        $this->setNrsequitreti($seq);
        $this->setProduto($objProduto);
        $this->setQtretirada($qtRetirada);
        $this->setQtprevisreti($qtPrevisao);
        $this->setQtextrareti($qtExtra);
        $this->setQtdevolvreti($qtEvol);
        $this->setDtinclusao($dtInclusao);
        $this->setCdoperinclusao($operInclusao);
        $this->setDtultatu($dtInclusao);
        $this->setCdprato($cdprato);
        $this->setCdfilauxprat($cdfilauxprat);
        $this->setCdtipoprat($cdtipoprat);

        $this->persist();

        return $this;
    }


    public function atualizaItem(
        $nrorg, $produto, $tipoReti, $qtExtra, $qtConsumida, $qtDevolvida, $operAtual
    ){
        $dtAtual = \Geral\Util\DateUtil::getDataAtual();

        $this->setNrorginclusao($nrorg);
        $this->setCdproduto($produto);
        $this->setCdtiporeti($tipoReti);
        $this->setQtextrareti($qtExtra);
        $this->setQtretirada($qtConsumida);
        $this->setQtdevolvreti($qtDevolvida);
        $this->setCdoperultatu($operAtual);
        $this->setDtultatu($dtAtual);

        $this->persist();

        return $this;
    }


    public function atualizaRelacaoLancto($filialLancto, $nrorg, $nrLancto, $seqLancto, $operAtual){
        $dt = \Geral\Util\DateUtil::getDataAtual();

        $this->setCdfiitlanest($filialLancto);
        $this->setNrsequitem($seqLancto);
        $this->setNrlancestq($nrLancto);
        $this->setDtultatu($dt);
        $this->setNrorgultatu($nrorg);
        $this->setCdoperultatu($operAtual);

        $this->persist();

        return $this;
    }


}