/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ASSUNTO                                                  */
/* Tabela : ASSUNTO                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ASSUNTO' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ASSUNTO
GO

CREATE TRIGGER DTULTATU_ASSUNTO
ON ASSUNTO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ASSUNTO', null, 'CDASSUNTO='+ CDASSUNTO + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ASSUNTO
      SET DTULTATUTASS = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ASSUNTO.CDASSUNTO,0)  = ISNULL(INSERTED.CDASSUNTO,0)) AND
            (ISNULL(ASSUNTO.NMASSUNTO,0)  = ISNULL(INSERTED.NMASSUNTO,0)) AND
            (ISNULL(ASSUNTO.CDNATUASSU,0) = ISNULL(INSERTED.CDNATUASSU,0));
   END;
END;
GO

