/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: CUSTO_PRODCONS

Descrio:
Retorna o custo de um Produto em uma determinada data.

P_CDFILIAL     - Cdigo da Filial.
P_CDPRODUTO    - Cdigo do Produto.
P_NRTIPOCUST   - Nmero do Tipo de Custo (1 a 10)
P_DTREFERENCIA - Data do Custo.

TIPOS DE CUSTO:

01 Custo Mdio Lquido Atual
02 Custo Mdio Bruto Atual
03 Custo Mdio Lquido da poca
04 Custo Mdio Bruto da poca
05 Custo da ltima Compra (NF)
06 Custo de Cotao (Lista de Preos)
07 Custo da ltima compra(AF)
20 Custo Mdio Lquido Atual
21 Custo Mdio Lquido Atual
22 Custo Mdio Bruto Atual
23 Custo Mdio Bruto Atual
24 Custo Mdio Lquido da poca
25 Custo Mdio Lquido da poca
26 Custo Mdio Bruto da poca
27 Custo Mdio Bruto da poca
28 Custo da ltima Compra (NF)
29 Custo da ltima Compra (NF)
30 Custo de Cotao (Lista de Preos)
31 Custo de Cotao (Lista de Preos)
32 Custo da ltima Compra(AF)
33 Custo da ltima Compra(AF)
34 Custo Mdio Atualizado

@C:\WIN_V4\SQL\END_CONV\ORACLE\0318_ESTFUNO.SQL

Criao:
21/01/2004 - Alessandra Cristina

*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'CUSTO_PRODCONS' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION CUSTO_PRODCONS
GO
CREATE FUNCTION CUSTO_PRODCONS(   @P_CDFILIAL     VARCHAR(4),
   @P_CDPRODUTO    VARCHAR(10),
   @P_NRTIPOCUSTO  INT,
   @P_DTREFERENCIA DATETIME,
   @P_DTATUAL      DATETIME) RETURNS NUMERIC(10,5)
AS
BEGIN
   DECLARE @V_CUSTO NUMERIC(10,5);

   SELECT @V_CUSTO = TEKNISA.CUSTO_PRODUTO(@P_CDFILIAL, @P_CDPRODUTO, @P_NRTIPOCUSTO, @P_DTREFERENCIA, @P_DTATUAL)
   FROM PARAMGERAL 

   RETURN(@V_CUSTO);

END
GO
